<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Repetido</title>
</head>

<body>

    <script>
        /* 
            Faça um algoritmo que retorne a a letra mias repetida de uma string
        */
        function mostUsedChar(text) {
            // implementar logica aqui
            let Letras = {};
            let maiorQuantidade = 0;

            text 
                .split("")                              // Usado para separar os caracteres
                .forEach(char => {                      // Confere cada caractere de uma string
                    if (char != " ") {
                        if (Letras[char] == null) {
                            Letras[char] = 1;
                        } else {
                            Letras[char] += 1;
                        }
                    }
                });

            for (const main in Letras) {
                if (Letras[main] > maiorQuantidade){
                    maiorQuantidade = Letras[main];
                }
            }

            let resultado = "";

            for (let i in Letras) {
                if (Letras[i] === maiorQuantidade) {
                    resultado = resultado + i;
                }
            }

            return resultado;
        }

        // Resultados esperados
        console.log(mostUsedChar("fdgdfgff"), 'f') // f
        console.log(mostUsedChar("Lorem ipsum"), 'm') // m
        console.log(mostUsedChar("adsassdasd"), 's') // s
        console.log(mostUsedChar("testeeeee"), 'e') // e

    </script>
</body>

</html>